{"cells": [{"cell_type": "markdown", "metadata": {}, "source": ["# Cheat Sheet on Graphs\n", "\n", "Links, pointers on many plotting libraries."]}, {"cell_type": "code", "execution_count": 1, "metadata": {}, "outputs": [{"data": {"text/html": ["<div id=\"my_id_menu_nb\">run previous cell, wait for 2 seconds</div>\n", "<script>\n", "function repeat_indent_string(n){\n", "    var a = \"\" ;\n", "    for ( ; n > 0 ; --n)\n", "        a += \"    \";\n", "    return a;\n", "}\n", "// look up into all sections and builds an automated menu //\n", "var update_menu_string = function(begin, lfirst, llast, sformat, send, keep_item, begin_format, end_format) {\n", "    var anchors = document.getElementsByClassName(\"section\");\n", "    if (anchors.length == 0) {\n", "        anchors = document.getElementsByClassName(\"text_cell_render rendered_html\");\n", "    }\n", "    var i,t;\n", "    var text_menu = begin;\n", "    var text_memo = \"<pre>\\nlength:\" + anchors.length + \"\\n\";\n", "    var ind = \"\";\n", "    var memo_level = 1;\n", "    var href;\n", "    var tags = [];\n", "    var main_item = 0;\n", "    var format_open = 0;\n", "    for (i = 0; i <= llast; i++)\n", "        tags.push(\"h\" + i);\n", "\n", "    for (i = 0; i < anchors.length; i++) {\n", "        text_memo += \"**\" + anchors[i].id + \"--\\n\";\n", "\n", "        var child = null;\n", "        for(t = 0; t < tags.length; t++) {\n", "            var r = anchors[i].getElementsByTagName(tags[t]);\n", "            if (r.length > 0) {\n", "child = r[0];\n", "break;\n", "            }\n", "        }\n", "        if (child == null) {\n", "            text_memo += \"null\\n\";\n", "            continue;\n", "        }\n", "        if (anchors[i].hasAttribute(\"id\")) {\n", "            // when converted in RST\n", "            href = anchors[i].id;\n", "            text_memo += \"#1-\" + href;\n", "            // passer \u00e0 child suivant (le chercher)\n", "        }\n", "        else if (child.hasAttribute(\"id\")) {\n", "            // in a notebook\n", "            href = child.id;\n", "            text_memo += \"#2-\" + href;\n", "        }\n", "        else {\n", "            text_memo += \"#3-\" + \"*\" + \"\\n\";\n", "            continue;\n", "        }\n", "        var title = child.textContent;\n", "        var level = parseInt(child.tagName.substring(1,2));\n", "\n", "        text_memo += \"--\" + level + \"?\" + lfirst + \"--\" + title + \"\\n\";\n", "\n", "        if ((level < lfirst) || (level > llast)) {\n", "            continue ;\n", "        }\n", "        if (title.endsWith('\u00b6')) {\n", "            title = title.substring(0,title.length-1).replace(\"<\", \"&lt;\")\n", "         .replace(\">\", \"&gt;\").replace(\"&\", \"&amp;\");\n", "        }\n", "        if (title.length == 0) {\n", "            continue;\n", "        }\n", "\n", "        while (level < memo_level) {\n", "            text_menu += end_format + \"</ul>\\n\";\n", "            format_open -= 1;\n", "            memo_level -= 1;\n", "        }\n", "        if (level == lfirst) {\n", "            main_item += 1;\n", "        }\n", "        if (keep_item != -1 && main_item != keep_item + 1) {\n", "            // alert(main_item + \" - \" + level + \" - \" + keep_item);\n", "            continue;\n", "        }\n", "        while (level > memo_level) {\n", "            text_menu += \"<ul>\\n\";\n", "            memo_level += 1;\n", "        }\n", "        text_menu += repeat_indent_string(level-2);\n", "        text_menu += begin_format + sformat.replace(\"__HREF__\", href).replace(\"__TITLE__\", title);\n", "        format_open += 1;\n", "    }\n", "    while (1 < memo_level) {\n", "        text_menu += end_format + \"</ul>\\n\";\n", "        memo_level -= 1;\n", "        format_open -= 1;\n", "    }\n", "    text_menu += send;\n", "    //text_menu += \"\\n\" + text_memo;\n", "\n", "    while (format_open > 0) {\n", "        text_menu += end_format;\n", "        format_open -= 1;\n", "    }\n", "    return text_menu;\n", "};\n", "var update_menu = function() {\n", "    var sbegin = \"\";\n", "    var sformat = '<a href=\"#__HREF__\">__TITLE__</a>';\n", "    var send = \"\";\n", "    var begin_format = '<li>';\n", "    var end_format = '</li>';\n", "    var keep_item = -1;\n", "    var text_menu = update_menu_string(sbegin, 2, 4, sformat, send, keep_item,\n", "       begin_format, end_format);\n", "    var menu = document.getElementById(\"my_id_menu_nb\");\n", "    menu.innerHTML=text_menu;\n", "};\n", "window.setTimeout(update_menu,2000);\n", "            </script>"], "text/plain": ["<IPython.core.display.HTML object>"]}, "execution_count": 2, "metadata": {}, "output_type": "execute_result"}], "source": ["from jyquickhelper import add_notebook_menu\n", "add_notebook_menu()"]}, {"cell_type": "markdown", "metadata": {}, "source": ["## Notebook start\n", "\n", "To include graphs in a notebook, many modules require to execute a line before it is imported.\n", "\n", "[matplotlib](http://matplotlib.org/)"]}, {"cell_type": "code", "execution_count": 2, "metadata": {}, "outputs": [], "source": ["%matplotlib inline"]}, {"cell_type": "markdown", "metadata": {}, "source": ["Changing style"]}, {"cell_type": "code", "execution_count": 3, "metadata": {}, "outputs": [], "source": ["import matplotlib.pyplot as plt\n", "plt.style.use('ggplot')"]}, {"cell_type": "markdown", "metadata": {}, "source": ["Available styles:"]}, {"cell_type": "code", "execution_count": 4, "metadata": {}, "outputs": [{"data": {"text/plain": ["['bmh',\n", " 'classic',\n", " 'dark_background',\n", " 'fast',\n", " 'fivethirtyeight',\n", " 'ggplot',\n", " 'grayscale',\n", " 'seaborn-bright',\n", " 'seaborn-colorblind',\n", " 'seaborn-dark-palette',\n", " 'seaborn-dark',\n", " 'seaborn-darkgrid',\n", " 'seaborn-deep',\n", " 'seaborn-muted',\n", " 'seaborn-notebook',\n", " 'seaborn-paper',\n", " 'seaborn-pastel',\n", " 'seaborn-poster',\n", " 'seaborn-talk',\n", " 'seaborn-ticks',\n", " 'seaborn-white',\n", " 'seaborn-whitegrid',\n", " 'seaborn',\n", " 'Solarize_Light2',\n", " 'tableau-colorblind10',\n", " '_classic_test']"]}, "execution_count": 5, "metadata": {}, "output_type": "execute_result"}], "source": ["plt.style.available"]}, {"cell_type": "markdown", "metadata": {}, "source": ["[bokeh](http://bokeh.pydata.org/en/latest/)"]}, {"cell_type": "code", "execution_count": 5, "metadata": {}, "outputs": [{"data": {"text/html": ["\n", "    <div class=\"bk-root\">\n", "        <a href=\"https://bokeh.pydata.org\" target=\"_blank\" class=\"bk-logo bk-logo-small bk-logo-notebook\"></a>\n", "        <span id=\"699839b9-3c7e-404f-acdd-65513a04a35a\">Loading BokehJS ...</span>\n", "    </div>"]}, "metadata": {}, "output_type": "display_data"}, {"data": {"application/javascript": ["\n", "(function(root) {\n", "  function now() {\n", "    return new Date();\n", "  }\n", "\n", "  var force = true;\n", "\n", "  if (typeof (root._bokeh_onload_callbacks) === \"undefined\" || force === true) {\n", "    root._bokeh_onload_callbacks = [];\n", "    root._bokeh_is_loading = undefined;\n", "  }\n", "\n", "  var JS_MIME_TYPE = 'application/javascript';\n", "  var HTML_MIME_TYPE = 'text/html';\n", "  var EXEC_MIME_TYPE = 'application/vnd.bokehjs_exec.v0+json';\n", "  var CLASS_NAME = 'output_bokeh rendered_html';\n", "\n", "  /**\n", "   * Render data to the DOM node\n", "   */\n", "  function render(props, node) {\n", "    var script = document.createElement(\"script\");\n", "    node.appendChild(script);\n", "  }\n", "\n", "  /**\n", "   * Handle when an output is cleared or removed\n", "   */\n", "  function handleClearOutput(event, handle) {\n", "    var cell = handle.cell;\n", "\n", "    var id = cell.output_area._bokeh_element_id;\n", "    var server_id = cell.output_area._bokeh_server_id;\n", "    // Clean up Bokeh references\n", "    if (id != null && id in Bokeh.index) {\n", "      Bokeh.index[id].model.document.clear();\n", "      delete Bokeh.index[id];\n", "    }\n", "\n", "    if (server_id !== undefined) {\n", "      // Clean up Bokeh references\n", "      var cmd = \"from bokeh.io.state import curstate; print(curstate().uuid_to_server['\" + server_id + \"'].get_sessions()[0].document.roots[0]._id)\";\n", "      cell.notebook.kernel.execute(cmd, {\n", "        iopub: {\n", "          output: function(msg) {\n", "            var id = msg.content.text.trim();\n", "            if (id in Bokeh.index) {\n", "              Bokeh.index[id].model.document.clear();\n", "              delete Bokeh.index[id];\n", "            }\n", "          }\n", "        }\n", "      });\n", "      // Destroy server and session\n", "      var cmd = \"import bokeh.io.notebook as ion; ion.destroy_server('\" + server_id + \"')\";\n", "      cell.notebook.kernel.execute(cmd);\n", "    }\n", "  }\n", "\n", "  /**\n", "   * Handle when a new output is added\n", "   */\n", "  function handleAddOutput(event, handle) {\n", "    var output_area = handle.output_area;\n", "    var output = handle.output;\n", "\n", "    // limit handleAddOutput to display_data with EXEC_MIME_TYPE content only\n", "    if ((output.output_type != \"display_data\") || (!output.data.hasOwnProperty(EXEC_MIME_TYPE))) {\n", "      return\n", "    }\n", "\n", "    var toinsert = output_area.element.find(\".\" + CLASS_NAME.split(' ')[0]);\n", "\n", "    if (output.metadata[EXEC_MIME_TYPE][\"id\"] !== undefined) {\n", "      toinsert[toinsert.length - 1].firstChild.textContent = output.data[JS_MIME_TYPE];\n", "      // store reference to embed id on output_area\n", "      output_area._bokeh_element_id = output.metadata[EXEC_MIME_TYPE][\"id\"];\n", "    }\n", "    if (output.metadata[EXEC_MIME_TYPE][\"server_id\"] !== undefined) {\n", "      var bk_div = document.createElement(\"div\");\n", "      bk_div.innerHTML = output.data[HTML_MIME_TYPE];\n", "      var script_attrs = bk_div.children[0].attributes;\n", "      for (var i = 0; i < script_attrs.length; i++) {\n", "        toinsert[toinsert.length - 1].firstChild.setAttribute(script_attrs[i].name, script_attrs[i].value);\n", "      }\n", "      // store reference to server id on output_area\n", "      output_area._bokeh_server_id = output.metadata[EXEC_MIME_TYPE][\"server_id\"];\n", "    }\n", "  }\n", "\n", "  function register_renderer(events, OutputArea) {\n", "\n", "    function append_mime(data, metadata, element) {\n", "      // create a DOM node to render to\n", "      var toinsert = this.create_output_subarea(\n", "        metadata,\n", "        CLASS_NAME,\n", "        EXEC_MIME_TYPE\n", "      );\n", "      this.keyboard_manager.register_events(toinsert);\n", "      // Render to node\n", "      var props = {data: data, metadata: metadata[EXEC_MIME_TYPE]};\n", "      render(props, toinsert[toinsert.length - 1]);\n", "      element.append(toinsert);\n", "      return toinsert\n", "    }\n", "\n", "    /* Handle when an output is cleared or removed */\n", "    events.on('clear_output.CodeCell', handleClearOutput);\n", "    events.on('delete.Cell', handleClearOutput);\n", "\n", "    /* Handle when a new output is added */\n", "    events.on('output_added.OutputArea', handleAddOutput);\n", "\n", "    /**\n", "     * Register the mime type and append_mime function with output_area\n", "     */\n", "    OutputArea.prototype.register_mime_type(EXEC_MIME_TYPE, append_mime, {\n", "      /* Is output safe? */\n", "      safe: true,\n", "      /* Index of renderer in `output_area.display_order` */\n", "      index: 0\n", "    });\n", "  }\n", "\n", "  // register the mime type if in Jupyter Notebook environment and previously unregistered\n", "  if (root.Jupyter !== undefined) {\n", "    var events = require('base/js/events');\n", "    var OutputArea = require('notebook/js/outputarea').OutputArea;\n", "\n", "    if (OutputArea.prototype.mime_types().indexOf(EXEC_MIME_TYPE) == -1) {\n", "      register_renderer(events, OutputArea);\n", "    }\n", "  }\n", "\n", "  \n", "  if (typeof (root._bokeh_timeout) === \"undefined\" || force === true) {\n", "    root._bokeh_timeout = Date.now() + 5000;\n", "    root._bokeh_failed_load = false;\n", "  }\n", "\n", "  var NB_LOAD_WARNING = {'data': {'text/html':\n", "     \"<div style='background-color: #fdd'>\\n\"+\n", "     \"<p>\\n\"+\n", "     \"BokehJS does not appear to have successfully loaded. If loading BokehJS from CDN, this \\n\"+\n", "     \"may be due to a slow or bad network connection. Possible fixes:\\n\"+\n", "     \"</p>\\n\"+\n", "     \"<ul>\\n\"+\n", "     \"<li>re-rerun `output_notebook()` to attempt to load from CDN again, or</li>\\n\"+\n", "     \"<li>use INLINE resources instead, as so:</li>\\n\"+\n", "     \"</ul>\\n\"+\n", "     \"<code>\\n\"+\n", "     \"from bokeh.resources import INLINE\\n\"+\n", "     \"output_notebook(resources=INLINE)\\n\"+\n", "     \"</code>\\n\"+\n", "     \"</div>\"}};\n", "\n", "  function display_loaded() {\n", "    var el = document.getElementById(\"699839b9-3c7e-404f-acdd-65513a04a35a\");\n", "    if (el != null) {\n", "      el.textContent = \"BokehJS is loading...\";\n", "    }\n", "    if (root.Bokeh !== undefined) {\n", "      if (el != null) {\n", "        el.textContent = \"BokehJS \" + root.Bokeh.version + \" successfully loaded.\";\n", "      }\n", "    } else if (Date.now() < root._bokeh_timeout) {\n", "      setTimeout(display_loaded, 100)\n", "    }\n", "  }\n", "\n", "\n", "  function run_callbacks() {\n", "    try {\n", "      root._bokeh_onload_callbacks.forEach(function(callback) { callback() });\n", "    }\n", "    finally {\n", "      delete root._bokeh_onload_callbacks\n", "    }\n", "    console.info(\"Bokeh: all callbacks have finished\");\n", "  }\n", "\n", "  function load_libs(js_urls, callback) {\n", "    root._bokeh_onload_callbacks.push(callback);\n", "    if (root._bokeh_is_loading > 0) {\n", "      console.log(\"Bokeh: BokehJS is being loaded, scheduling callback at\", now());\n", "      return null;\n", "    }\n", "    if (js_urls == null || js_urls.length === 0) {\n", "      run_callbacks();\n", "      return null;\n", "    }\n", "    console.log(\"Bokeh: BokehJS not loaded, scheduling load and callback at\", now());\n", "    root._bokeh_is_loading = js_urls.length;\n", "    for (var i = 0; i < js_urls.length; i++) {\n", "      var url = js_urls[i];\n", "      var s = document.createElement('script');\n", "      s.src = url;\n", "      s.async = false;\n", "      s.onreadystatechange = s.onload = function() {\n", "        root._bokeh_is_loading--;\n", "        if (root._bokeh_is_loading === 0) {\n", "          console.log(\"Bokeh: all BokehJS libraries loaded\");\n", "          run_callbacks()\n", "        }\n", "      };\n", "      s.onerror = function() {\n", "        console.warn(\"failed to load library \" + url);\n", "      };\n", "      console.log(\"Bokeh: injecting script tag for BokehJS library: \", url);\n", "      document.getElementsByTagName(\"head\")[0].appendChild(s);\n", "    }\n", "  };var element = document.getElementById(\"699839b9-3c7e-404f-acdd-65513a04a35a\");\n", "  if (element == null) {\n", "    console.log(\"Bokeh: ERROR: autoload.js configured with elementid '699839b9-3c7e-404f-acdd-65513a04a35a' but no matching script tag was found. \")\n", "    return false;\n", "  }\n", "\n", "  var js_urls = [\"https://cdn.pydata.org/bokeh/release/bokeh-0.13.0.min.js\", \"https://cdn.pydata.org/bokeh/release/bokeh-widgets-0.13.0.min.js\", \"https://cdn.pydata.org/bokeh/release/bokeh-tables-0.13.0.min.js\", \"https://cdn.pydata.org/bokeh/release/bokeh-gl-0.13.0.min.js\"];\n", "\n", "  var inline_js = [\n", "    function(Bokeh) {\n", "      Bokeh.set_log_level(\"info\");\n", "    },\n", "    \n", "    function(Bokeh) {\n", "      \n", "    },\n", "    function(Bokeh) {\n", "      console.log(\"Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-0.13.0.min.css\");\n", "      Bokeh.embed.inject_css(\"https://cdn.pydata.org/bokeh/release/bokeh-0.13.0.min.css\");\n", "      console.log(\"Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-widgets-0.13.0.min.css\");\n", "      Bokeh.embed.inject_css(\"https://cdn.pydata.org/bokeh/release/bokeh-widgets-0.13.0.min.css\");\n", "      console.log(\"Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-tables-0.13.0.min.css\");\n", "      Bokeh.embed.inject_css(\"https://cdn.pydata.org/bokeh/release/bokeh-tables-0.13.0.min.css\");\n", "    }\n", "  ];\n", "\n", "  function run_inline_js() {\n", "    \n", "    if ((root.Bokeh !== undefined) || (force === true)) {\n", "      for (var i = 0; i < inline_js.length; i++) {\n", "        inline_js[i].call(root, root.Bokeh);\n", "      }if (force === true) {\n", "        display_loaded();\n", "      }} else if (Date.now() < root._bokeh_timeout) {\n", "      setTimeout(run_inline_js, 100);\n", "    } else if (!root._bokeh_failed_load) {\n", "      console.log(\"Bokeh: BokehJS failed to load within specified timeout.\");\n", "      root._bokeh_failed_load = true;\n", "    } else if (force !== true) {\n", "      var cell = $(document.getElementById(\"699839b9-3c7e-404f-acdd-65513a04a35a\")).parents('.cell').data().cell;\n", "      cell.output_area.append_execute_result(NB_LOAD_WARNING)\n", "    }\n", "\n", "  }\n", "\n", "  if (root._bokeh_is_loading === 0) {\n", "    console.log(\"Bokeh: BokehJS loaded, going straight to plotting\");\n", "    run_inline_js();\n", "  } else {\n", "    load_libs(js_urls, function() {\n", "      console.log(\"Bokeh: BokehJS plotting callback run at\", now());\n", "      run_inline_js();\n", "    });\n", "  }\n", "}(window));"], "application/vnd.bokehjs_load.v0+json": "\n(function(root) {\n  function now() {\n    return new Date();\n  }\n\n  var force = true;\n\n  if (typeof (root._bokeh_onload_callbacks) === \"undefined\" || force === true) {\n    root._bokeh_onload_callbacks = [];\n    root._bokeh_is_loading = undefined;\n  }\n\n  \n\n  \n  if (typeof (root._bokeh_timeout) === \"undefined\" || force === true) {\n    root._bokeh_timeout = Date.now() + 5000;\n    root._bokeh_failed_load = false;\n  }\n\n  var NB_LOAD_WARNING = {'data': {'text/html':\n     \"<div style='background-color: #fdd'>\\n\"+\n     \"<p>\\n\"+\n     \"BokehJS does not appear to have successfully loaded. If loading BokehJS from CDN, this \\n\"+\n     \"may be due to a slow or bad network connection. Possible fixes:\\n\"+\n     \"</p>\\n\"+\n     \"<ul>\\n\"+\n     \"<li>re-rerun `output_notebook()` to attempt to load from CDN again, or</li>\\n\"+\n     \"<li>use INLINE resources instead, as so:</li>\\n\"+\n     \"</ul>\\n\"+\n     \"<code>\\n\"+\n     \"from bokeh.resources import INLINE\\n\"+\n     \"output_notebook(resources=INLINE)\\n\"+\n     \"</code>\\n\"+\n     \"</div>\"}};\n\n  function display_loaded() {\n    var el = document.getElementById(\"699839b9-3c7e-404f-acdd-65513a04a35a\");\n    if (el != null) {\n      el.textContent = \"BokehJS is loading...\";\n    }\n    if (root.Bokeh !== undefined) {\n      if (el != null) {\n        el.textContent = \"BokehJS \" + root.Bokeh.version + \" successfully loaded.\";\n      }\n    } else if (Date.now() < root._bokeh_timeout) {\n      setTimeout(display_loaded, 100)\n    }\n  }\n\n\n  function run_callbacks() {\n    try {\n      root._bokeh_onload_callbacks.forEach(function(callback) { callback() });\n    }\n    finally {\n      delete root._bokeh_onload_callbacks\n    }\n    console.info(\"Bokeh: all callbacks have finished\");\n  }\n\n  function load_libs(js_urls, callback) {\n    root._bokeh_onload_callbacks.push(callback);\n    if (root._bokeh_is_loading > 0) {\n      console.log(\"Bokeh: BokehJS is being loaded, scheduling callback at\", now());\n      return null;\n    }\n    if (js_urls == null || js_urls.length === 0) {\n      run_callbacks();\n      return null;\n    }\n    console.log(\"Bokeh: BokehJS not loaded, scheduling load and callback at\", now());\n    root._bokeh_is_loading = js_urls.length;\n    for (var i = 0; i < js_urls.length; i++) {\n      var url = js_urls[i];\n      var s = document.createElement('script');\n      s.src = url;\n      s.async = false;\n      s.onreadystatechange = s.onload = function() {\n        root._bokeh_is_loading--;\n        if (root._bokeh_is_loading === 0) {\n          console.log(\"Bokeh: all BokehJS libraries loaded\");\n          run_callbacks()\n        }\n      };\n      s.onerror = function() {\n        console.warn(\"failed to load library \" + url);\n      };\n      console.log(\"Bokeh: injecting script tag for BokehJS library: \", url);\n      document.getElementsByTagName(\"head\")[0].appendChild(s);\n    }\n  };var element = document.getElementById(\"699839b9-3c7e-404f-acdd-65513a04a35a\");\n  if (element == null) {\n    console.log(\"Bokeh: ERROR: autoload.js configured with elementid '699839b9-3c7e-404f-acdd-65513a04a35a' but no matching script tag was found. \")\n    return false;\n  }\n\n  var js_urls = [\"https://cdn.pydata.org/bokeh/release/bokeh-0.13.0.min.js\", \"https://cdn.pydata.org/bokeh/release/bokeh-widgets-0.13.0.min.js\", \"https://cdn.pydata.org/bokeh/release/bokeh-tables-0.13.0.min.js\", \"https://cdn.pydata.org/bokeh/release/bokeh-gl-0.13.0.min.js\"];\n\n  var inline_js = [\n    function(Bokeh) {\n      Bokeh.set_log_level(\"info\");\n    },\n    \n    function(Bokeh) {\n      \n    },\n    function(Bokeh) {\n      console.log(\"Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-0.13.0.min.css\");\n      Bokeh.embed.inject_css(\"https://cdn.pydata.org/bokeh/release/bokeh-0.13.0.min.css\");\n      console.log(\"Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-widgets-0.13.0.min.css\");\n      Bokeh.embed.inject_css(\"https://cdn.pydata.org/bokeh/release/bokeh-widgets-0.13.0.min.css\");\n      console.log(\"Bokeh: injecting CSS: https://cdn.pydata.org/bokeh/release/bokeh-tables-0.13.0.min.css\");\n      Bokeh.embed.inject_css(\"https://cdn.pydata.org/bokeh/release/bokeh-tables-0.13.0.min.css\");\n    }\n  ];\n\n  function run_inline_js() {\n    \n    if ((root.Bokeh !== undefined) || (force === true)) {\n      for (var i = 0; i < inline_js.length; i++) {\n        inline_js[i].call(root, root.Bokeh);\n      }if (force === true) {\n        display_loaded();\n      }} else if (Date.now() < root._bokeh_timeout) {\n      setTimeout(run_inline_js, 100);\n    } else if (!root._bokeh_failed_load) {\n      console.log(\"Bokeh: BokehJS failed to load within specified timeout.\");\n      root._bokeh_failed_load = true;\n    } else if (force !== true) {\n      var cell = $(document.getElementById(\"699839b9-3c7e-404f-acdd-65513a04a35a\")).parents('.cell').data().cell;\n      cell.output_area.append_execute_result(NB_LOAD_WARNING)\n    }\n\n  }\n\n  if (root._bokeh_is_loading === 0) {\n    console.log(\"Bokeh: BokehJS loaded, going straight to plotting\");\n    run_inline_js();\n  } else {\n    load_libs(js_urls, function() {\n      console.log(\"Bokeh: BokehJS plotting callback run at\", now());\n      run_inline_js();\n    });\n  }\n}(window));"}, "metadata": {}, "output_type": "display_data"}], "source": ["import bokeh.plotting as bplt\n", "bplt.output_notebook()"]}, {"cell_type": "markdown", "metadata": {}, "source": ["[pyecharts](https://github.com/pyecharts/pyecharts)"]}, {"cell_type": "code", "execution_count": 6, "metadata": {}, "outputs": [], "source": ["import pyecharts"]}, {"cell_type": "markdown", "metadata": {}, "source": ["## Change style\n", "\n", "Only with [matplotlib](http://matplotlib.org/)"]}, {"cell_type": "code", "execution_count": 7, "metadata": {}, "outputs": [], "source": ["import matplotlib.pyplot as plt\n", "plt.style.use('ggplot')"]}, {"cell_type": "markdown", "metadata": {}, "source": ["## If you want to draw a..."]}, {"cell_type": "markdown", "metadata": {}, "source": ["### Basic graph as images\n", "\n", "* [maplotlib](http://matplotlib.org/)\n", "* [pandas.DataFrame.plot](http://pandas.pydata.org/pandas-docs/stable/visualization.html)"]}, {"cell_type": "markdown", "metadata": {}, "source": ["### Basic graphs as javascript\n", "\n", "* [bokeh](http://bokeh.pydata.org/en/latest/)\n", "* [pygal](http://www.pygal.org/en/latest/)\n", "* [C3.js](http://www.xavierdupre.fr/app/jyquickhelper/helpsphinx/notebooks/notebook_graph_js.html)\n", "* [pyecharts](https://github.com/pyecharts/pyecharts)"]}, {"cell_type": "markdown", "metadata": {}, "source": ["### Animated graphs\n", "\n", "* [bokeh](http://bokeh.pydata.org/en/latest/)"]}, {"cell_type": "markdown", "metadata": {}, "source": ["### Maps\n", "\n", "* [cartopy](http://scitools.org.uk/cartopy/)\n", "* [folium](https://github.com/python-visualization/folium)"]}, {"cell_type": "markdown", "metadata": {}, "source": ["### Statistical graphs\n", "\n", "* [seaborn](http://stanford.edu/~mwaskom/software/seaborn/)"]}, {"cell_type": "markdown", "metadata": {}, "source": ["### Networks\n", "\n", "* [networkx](https://networkx.github.io/)\n", "* [graphviz](https://pypi.python.org/pypi/graphviz)"]}, {"cell_type": "markdown", "metadata": {}, "source": ["### More\n", "\n", "* [10 plotting librairies](http://www.xavierdupre.fr/app/jupytalk/helpsphinx/notebooks/10_plotting_libraries.html#plottinglibrariesrst)"]}, {"cell_type": "markdown", "metadata": {}, "source": ["## Notebooks and Python\n", "\n", "* [Graphes - \u00e9nonc\u00e9](http://www.xavierdupre.fr/app/actuariat_python/helpsphinx/notebooks/seance6_graphes_enonce.html) (French)\n", "* [Rappel de ce que vous savez d\u00e9j\u00e0 mais avez peut-\u00eatre oubli\u00e9](http://www.xavierdupre.fr/app/ensae_teaching_cs/helpsphinx/notebooks/td2_eco_rappels_1a.html)"]}, {"cell_type": "code", "execution_count": 8, "metadata": {}, "outputs": [], "source": []}], "metadata": {"kernelspec": {"display_name": "Python 3", "language": "python", "name": "python3"}, "language_info": {"codemirror_mode": {"name": "ipython", "version": 3}, "file_extension": ".py", "mimetype": "text/x-python", "name": "python", "nbconvert_exporter": "python", "pygments_lexer": "ipython3", "version": "3.7.0"}}, "nbformat": 4, "nbformat_minor": 2}